package com.gyee.runeconomy.config;

import com.baomidou.mybatisplus.core.exceptions.MybatisPlusException;
import com.baomidou.mybatisplus.generator.AutoGenerator;
import com.baomidou.mybatisplus.generator.config.*;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.baomidou.mybatisplus.generator.engine.FreemarkerTemplateEngine;
import com.gyee.runeconomy.util.StringUtils;

import java.util.Scanner;

/**
 * @ClassName GeneratorCodeConfig
 * @Description 自动生成mybatisplus的相关代码
 * @Author 谢生杰
 * @Date 2020/9/25 18:26
 * @Version 1.0
 **/
public class GeneratorCodeConfig {
    public static String scanner(String tip) {
        Scanner scanner = new Scanner(System.in);
        StringBuilder help = new StringBuilder();
        help.append("请输入" + tip + "：");
        System.out.println(help.toString());
        if (scanner.hasNext()) {
            String ipt = scanner.next();
            if (StringUtils.isNotEmpty(ipt)) {
                return ipt;
            }
        }
        throw new MybatisPlusException("请输入正确的" + tip + "！");
    }

    public static void main(String[] args) {
        // 代码生成器
        AutoGenerator mpg = new AutoGenerator();

        // 全局配置
        GlobalConfig gc = new GlobalConfig();
        String projectPath = System.getProperty("user.dir");
        //        gc.setOutputDir("D:\\work\\workspaces\\sis\\web\\runeconomy-xk\\src\\main\\java");
        gc.setOutputDir("D:\\work\\workspaces\\sis\\web\\runeconomy-xk\\src\\main\\java");
        gc.setAuthor("wang");
        gc.setOpen(false);
        //实体属性 Swagger2 注解
        gc.setSwagger2(false);
        mpg.setGlobalConfig(gc);

        // 数据源配置
        DataSourceConfig dsc = new DataSourceConfig();
        /*dsc.setUrl("jdbc:mysql://127.0.0.1:3306/test?serverTimezone=UTC&useUnicode=true&characterEncoding=utf-8&zeroDateTimeBehavior=convertToNull&useSSL=false&allowPublicKeyRetrieval=true");
        dsc.setDriverName("com.mysql.jdbc.Driver");
        dsc.setUsername("root");
        dsc.setPassword("root");
        mpg.setDataSource(dsc);*/
        //        dsc.setDriverName("oracle.jdbc.driver.OracleDriver"); 注意大写
        //        dsc.setUsername("gdprod");
        //        dsc.setPassword("gd123");
        //        dsc.setUrl("jdbc:oracle:thin:@10.81.3.151:1521:gdsj");

        dsc.setDriverName("org.postgresql.Driver");
        dsc.setUsername("postgres");
        dsc.setPassword("postgres");
        dsc.setUrl("jdbc:postgresql://10.81.3.151:5432/IMS_NEM_JN");

        mpg.setDataSource(dsc);


        // 包配置
        PackageConfig pc = new PackageConfig();
        //        pc.setModuleName(scanner("模块名"));
        pc.setParent("com.gyee.runeconomy");
        pc.setEntity("model.auto");
        pc.setMapper("mapper.auto");
        pc.setService("service.auto");
        pc.setServiceImpl("service.auto.impl");
        mpg.setPackageInfo(pc);

        // 自定义配置
        //        InjectionConfig cfg = new InjectionConfig() {
        //            @Override
        //            public void initMap() {
        //                // to do nothing
        //            }
        //        };

        // 如果模板引擎是 freemarker
        //        String templatePath = "/templates/mapper.xml.ftl";
        // 如果模板引擎是 velocity
        // String templatePath = "/templates/mapper.xml.vm";

        // 自定义输出配置
        //        List<FileOutConfig> focList = new ArrayList<>();
        // 自定义配置会被优先输出
        //        focList.add(new FileOutConfig(templatePath) {
        //            @Override
        //            public String outputFile(TableInfo tableInfo) {
        //                // 自定义输出文件名 ， 如果你 Entity 设置了前后缀、此处注意 xml 的名称会跟着发生变化！！
        //                return projectPath + "/src/main/resources/mapper/" + pc.getModuleName()
        //                        + "/" + tableInfo.getEntityName() + "Mapper" + StringPool.DOT_XML;
        //            }
        //        });
        /*
        cfg.setFileCreate(new IFileCreate() {
            @Override
            public boolean isCreate(ConfigBuilder configBuilder, FileType fileType, String filePath) {
                // 判断自定义文件夹是否需要创建
                checkDir("调用默认方法创建的目录");
                return false;
            }
        });
        */
        //        cfg.setFileOutConfigList(focList);
        //        mpg.setCfg(cfg);

        // 配置模板
        TemplateConfig templateConfig = new TemplateConfig();

        // 配置自定义输出模板
        //指定自定义模板路径，注意不要带上.ftl/.vm, 会根据使用的模板引擎自动识别
        // templateConfig.setEntity("templates/entity2.java");
        // templateConfig.setService();
        // templateConfig.setController();

        templateConfig.setXml(null);
        mpg.setTemplate(templateConfig);

        // 策略配置
        StrategyConfig strategy = new StrategyConfig();
        strategy.setNaming(NamingStrategy.underline_to_camel);
        strategy.setColumnNaming(NamingStrategy.underline_to_camel);
        strategy.setSuperEntityClass("com.baomidou.mybatisplus.extension.activerecord.Model");
        strategy.setEntityLombokModel(true);
        strategy.setRestControllerStyle(true);

        strategy.setEntityLombokModel(true);
        // 公共父类
        //        strategy.setSuperControllerClass("com.baomidou.ant.common.BaseController");
        // 写于父类中的公共字段
        //        strategy.setSuperEntityColumns("id");
        strategy.setInclude(scanner("表名，多个英文逗号分割").split(","));
        strategy.setControllerMappingHyphenStyle(true);
        strategy.setTablePrefix(pc.getModuleName() + "_");
        mpg.setStrategy(strategy);
        mpg.setTemplateEngine(new FreemarkerTemplateEngine());
        mpg.execute();
    }
}
